local L,SN,ST = DXE.L,DXE.SN,DXE.ST

------------------------
-- Alysrazor
------------------------
do
	local data = {
		version = 1,
		key = "Alysrazor",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Alysrazor"],
		triggers = {
			scan = {
				52530, -- Alysrazor
			},
		},
		onactivate = {
			tracing = {52530}, -- Alysrazor
            tracerstart = true,
			combatstop = true,
			defeat = 52530,
		},
        userdata = {
			imprintedtext = "",
        },
        onstart = {
        },
        windows = {
        },
        timers = {
        },
		alerts = {
			firestorm = {
				varname = format(L.alert["%s Casting"],SN[100744]),
				type = "centerpopup",
				text = format(L.alert["%s Casting"],SN[100744]),
				time = 5,
				flashtime = 5,
				color1 = "YELLOW",
				color2 ="RED",
				sound = "ALERT12",
			},
			brushfire = {
				varname = format(L.alert["%s Casting"],SN[100717]),
				type = "simple",
				text = format(L.alert["%s Casting"],SN[100717]),
				time = 3,
				flashtime = 3,
				color1 = "ORANGE",
				sound = "ALERT2",
			},
			imprinted = {
				varname = format(L.alert["%s Warning"],SN[100360]),
				type = "simple",
				text = format(L.alert["%s on %s"],SN[100360],"<imprintedtext>"),
				time = 3,
				flashtime = 3,
				color1 = "BLACK",
				sound = "ALERT3",
			},
			tantrumcd = {
				varname = format(L.alert["%s Cooldown"],SN[100852]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[100852]),
				time = 15,
				flashtime = 5,
				color1 = "ORANGE",
				throttle = 2, --possbily
			},
			vortex = {
				varname = format(L.alert["%s Duration"],SN[99794]),
				type = "dropdown",
				text = format(L.alert["%s Duration"],SN[99794]),
				time = 30, --???
				flashtime = 5,
				color1 = "ORANGE",
			},
			burnout = {
				varname = format(L.alert["%s Duration"],SN[99432]),
				type = "dropdown",
				text = format(L.alert["%s Duration"],SN[99432]),
				time = 20,
				flashtime = 5,
				color1 = "YELLOW",
			},
			ignited = {
				varname = format(L.alert["%s Duration"],SN[99922]),
				type = "dropdown",
				text = format(L.alert["%s Duration"],SN[99922]),
				time = 12, -- or 16
				flashtime = 5,
				color1 = "YELLOW",
			},
		},
        announces = {
        },
        raidicons = {
        },
		events = {
			-- Phase 1
			-- Firestorm heroic only
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname= 100744,
				execute = {
					{
						"alert","firestorm",
					},
				},
			},
			-- Brushfire
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname= 100717,
				execute = {
					{
						"alert","brushfire",
					},
				},
			},
			-- Hatchling
			-- Imprinted 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APLLIED",
				spellname= 100360,
				execute = {
					{
						"set",{imprintedtext = "#5#"},
						"alert","imprinted",
					},
				},
			},
			-- Satiated 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APLLIED",
				spellname= 100852,
				execute = {
					{
						"alert","tantrumcd",
					},
				},
			},
			-- Worm (arrow?)
			
			-- Herald (heroic)
			-- Cataclysm
			
			-- Phase 2 (probably yell)
			-- Fiery Vortex
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellname= 99794,
				execute = {
					{
						"alert","vortex",
					},
				},
			},
			-- Phase 3 + 4
			-- Burnout
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname= 99432,
				execute = {
					{
						"alert","burnout",
					},
				},
			},
			-- Ignited , still adds up??
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname= 99922,
				execute = {
					{
						"quash","burnout",
						"alert","ignited",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end

------------------------
-- Baleroc
------------------------
do
	local data = {
		version = 1,
		key = "Baleroc",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Baleroc"],
		triggers = {
			scan = {
				53494, -- Baleroc
			},
		},
		onactivate = {
			tracing = {53494}, -- Baleroc
            tracerstart = true,
			combatstop = true,
			defeat = 53494,
		},
        userdata = {
			blazetext = "",
        },
        onstart = {
			{
				"expect",{"&difficulty&",">=","3"}, --10h&25h
				"alert","countdowncd",
			},
			{
				"alert","bladecd",
				"alert",{"shardcd",time = 2},
			},
        },
        windows = {
			proxwindow = true,
        },
        timers = {
        },
		alerts = {
			bladecd = {
				varname = format(L.alert["%s/%s Cooldown"],SN[99352],SN[99350]),
				type = "dropdown",
				text = format(L.alert["%s/%s Cooldown"],SN[99352],SN[99350]),
				time = 30,
				flashtime = 5,
				color1 = "BLUE",
				icon = ST[99252],
				sound = "ALERT1",
			},
			decimationbladewarn = {
				varname = format(L.alert["%s Warning"],SN[99352]),
				type = "dropdown",
				text = format(L.alert["%s Warning"],SN[99350]),
				time = 3,
				flashtime = 3,
				color1 = "PURPLE",
				icon = ST[99352],
				sound = "ALERT2",
			},
			decimationbladedur = {
				varname = format(L.alert["%s Duration"],SN[99352]),
				type = "dropdown",
				text = format(L.alert["%s Duration"],SN[99350]),
				time = 15,
				flashtime = 5,
				color1 = "PURPLE",
				icon = ST[99352],
			},
			infernobladewarn = {
				varname = format(L.alert["%s Warning"],SN[99350]),
				type = "dropdown",
				text = format(L.alert["%s Warning"],SN[99350]),
				time = 3,
				flashtime = 3,
				color1 = "YELLOW",
				icon = ST[99350],
				sound = "ALERT2",
			},
			infernobladedur = {
				varname = format(L.alert["%s Duration"],SN[99350]),
				type = "dropdown",
				text = format(L.alert["%s Duration"],SN[99350]),
				time = 15,
				flashtime = 5,
				color1 = "YELLOW",
				icon = ST[99350],
			},
			shardwarn = {
				varname = format(L.alert["%s Warning"],SN[99259]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[99259]),
				time = 3,
				flashtime = 3,
				color1 = "PURPLE",
				icon = ST[99259],
				sound = "ALERT3",
			},
			shardcd = {
				varname = format(L.alert["%s Cooldown"],SN[99259]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[99259]),
				time = 33,
				time2 = 5,
				flashtime = 5,
				color1 = "PURPLE",
				icon = ST[99259],
				sound = "ALERT3",
			},
			--[[ heroic
			countdowncd = {
			},
			countdownwarn = {
			},]]
		},
        announces = {
			--countdownsay = {},
        },
        raidicons = {
			--countdownicon = {},
        },
		arrows = {
			--countdownarrow = {},
		},
		events = {
			-- Decimation Blade
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 99352,
				execute = {
					{
						"quash","bladecd",
						"alert","bladecd",
						"alert","decimationbladewarn",
						"schedulealert",{"decimationbladedur",1.5},
					},
				},
			},
			-- Inferno Blade
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 99350,
				execute = {
					{
						"quash","bladecd",
						"alert","bladecd",
						"alert","infernobladewarn",
						"schedulealert",{"infernobladedur",1.5},
					},
				},
			},
			-- Shards of Torment
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 99259,
				execute = {
					{
						"quash","shardcd",
						"alert","shardcd",
						"alert","shardwarn",
					},
				},
			},
			-- Countdown heroic
		},
	}

	DXE:RegisterEncounter(data)
end


------------------------
-- Beth'tilac
------------------------
do
	local data = {
		version = 1,
		key = "Beth'tilac",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Beth'tilac"],
		triggers = {
			scan = {
				52498, -- Beth'tilac
			},
		},
		onactivate = {
			tracing = {52498}, -- Beth'tilac
            tracerstart = true,
			combatstop = true,
			defeat = 52498,
		},
        userdata = {
        },
        onstart = {
        },
        windows = {
        },
        timers = {
        },
		alerts = {
		},
        announces = {
        },
        raidicons = {
        },
		events = {
		},
	}

	DXE:RegisterEncounter(data)
end


------------------------
-- Lord Rhyolith
------------------------
do
	local data = {
		version = 1,
		key = "Rhyolith",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Lord Rhyolith"],
		triggers = {
			scan = {
				52558, -- Lord Rhyolith
			},
		},
		onactivate = {
			tracing = {52558}, -- Lord Rhyolith
            tracerstart = true,
			combatstop = true,
			defeat = 52558,
		},
        userdata = {
        },
        onstart = {
        },
        windows = {
        },
        timers = {
        },
		alerts = {
		},
        announces = {
        },
        raidicons = {
        },
		events = {
		},
	}

	DXE:RegisterEncounter(data)
end


------------------------
-- Majordomo Fandral Staghelm
------------------------
do
	local data = {
		version = 2,
		key = "Staghelm",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Majordomo Fandral Staghelm"],
		triggers = {
			scan = {
				52571, -- Majordomo Fandral Staghelm
			},
		},
		onactivate = {
			tracing = {52571,powers={true}}, -- Majordomo Fandral Staghelm
			tracerstart = true,
			combatstop = true,
			defeat = 52571,
		},
		userdata = {
			seedtime = 0,
			abilitycd = {19,14,8.5,7.3, loop = false, type = "series"},
		},
		onstart = {
		},
		windows = {
			proxwindow = true,
			proxrange = 12,
		},
		--timers = {},
		alerts = {
			catwarn = {
				varname = format(L.alert["%s Warning"],SN[98374]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[98374]),
				time = 3,
				flashtime = 3,
				color1 = "YELLOW",
				icon = ST[98374],
				sound = "ALERT1",
			},
			scorpionwarn = {
				varname = format(L.alert["%s Warning"],SN[98379]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[98379]),
				time = 3,
				flashtime = 3,
				color1 = "BROWN",
				icon = ST[98379],
				sound = "ALERT2",
			},
			orbswarn = {
				varname = format(L.alert["%s Warning"],SN[98451]),
				type = "centerpopup",
				text = format(L.alert["%s Warning"],SN[98451]),
				time = 4,
				flashtime = 4,
				color1 = "ORANGE",
				icon = ST[98451],
				sound = "ALERT3",
			},
			orbsdur = {
				varname = format(L.alert["%s Duration"],SN[98451]),
				type = "dropdown",
				text = format(L.alert["%s Duration"],SN[98451]),
				time = 60,
				flashtime = 10,
				color1 = "ORANGE",
				icon = ST[98451],
			},
			seedswarn = {
				varname = format(L.alert["%s Warning"],SN[98450]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[98450]),
				time = 4,
				flashtime = 4,
				color1 = "PURPLE",
				icon = ST[98450],
				sound = "ALERT4",
			},
			seedsself = {
				varname = format(L.alert["%s Warning"],SN[98450]),
				type = "dropdown",
				text = format(L.alert["%s on %s"],SN[98450],L.alert["YOU"]),
				time = "<seedtime>",
				flashtime = 4,
				color1 = "PURPLE",
				icon = ST[98450],
				sound = "ALERT12",
			},
			-- abilitycd
		},
		--announces = {},
		--raidicons = {},
		events = {
			--Orbs
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 98451,
				execute = {
					{
						"alert","orbswarn",
						"schedulealert",{"orbsdur",4}
					},
				},
			},
			-- Seeds
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 98450,
				execute = {
					{
						"alert","seedswarn",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 98450,
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"set",{seedtime = "&playerdebuffdur|"..SN[98450].."&"},
						"alert","seedsself",
					},
				},
			},
			-- Yells (use buffs!)
			{
				type = "event",
				event = "YELL",
				execute = {
					-- Cat Form
					{
						"expect",{"#1#","find",L.chat_firelands["^Behold the rage of the Firelands"]},
						"alert","catwarn",
					},
					-- Scorpion Form
					{
						"expect",{"#1#","find",L.chat_firelands["^The master's power takes on many forms"]},
						"alert","scorpionwarn",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end


------------------------
-- Shannox
------------------------
do
	local data = {
		version = 1,
		key = "Shannox",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Shannox"],
		triggers = {
			scan = {
				53691, -- Shannox
			},
			yell = L.chat_firelands["Aha! The interlopers"],
		},
		onactivate = {
			tracing = {
				53691, -- Shannox
				53694, -- Riplimb
				53695, -- Rageface
			},
			tracerstart = true,
			combatstop = true,
			defeat = 53691,
		},
		userdata = {
			jaggedtext = "",
			traptext = "",
			traptype = "",
			immotrapcd = {16,10, loop = true, type = "series"},
			crystaltrapcd = {9,25, loop = false, type = "series"},
			spearcd = {18,41, loop = false, type = "series"},
		},
		onstart = {
			{
				"alert","spearcd",
				"alert","immotrapcd",
				"alert","crystaltrapcd",
			},
		},
		windows = {
		},
		arrows = {
			crystaltraparrow = {
				varname = format(L.npc_firelands["Crystal Prison"]),
				unit = "#5#",
				persist = 30,
				action = "TOWARD",
				msg = L.alert["Free him!"],
				spell = SN[98159],
				sound = "ALERT5",
			},
		},
		timers = {
		},
		alerts = {
			spearcd = {
				varname = format(L.alert["%s Cooldown"],SN[100002]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[100002]),
				time = "<spearcd>",
				flashtime = 5,
				color1 = "GREEN",
				icon = ST[100002],
			},
			spearwarn = {
				varname = format(L.alert["%s Warning"],SN[100002]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[100002]),
				time = 3,
				flashtime = 3,
				color1 = "GREEN",
				sound = "ALERT1",
				icon = ST[100002],
			},
			immotrapcd = {
				varname = format(L.alert["%s Cooldown"],SN[99839]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[99839]),
				time = "<immotrapcd>",
				flashtime = 5,
				color1 = "ORANGE",
				icon = ST[99839],
			},
			crystaltrapcd = {
				varname = format(L.alert["%s Cooldown"],SN[99836]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[99836]),
				time = "<crystaltrapcd>",
				flashtime = 5,
				color1 = "BLUE",
				icon = ST[99836],
			},
			crystaltrapwarn = {
				varname = format(L.alert["%s Warning"],SN[99836]),
				type = "simple",
				text = "<traptext>",
				time = 5,
				flashtime = 5,
				color1 = "BLUE",
				sound = "ALERT3",
				icon = ST[99836],
			},
			crystaltrapself = {
				varname = format(L.alert["%s Warning on self"],SN[99836]),
				type = "simple",
				text = format(L.alert["%s on %s"],SN[99836],L.alert["YOU"]),
				time = 5,
				flashtime = 5,
				color1 = "BLUE",
				sound = "ALERT3",
				icon = ST[99836],
			},
			trapwarn = {
				varname = format(L.alert["Trap Warning"]),
				type = "simple",
				text = format(L.alert["%s Trap on %s"],"<traptype>",L.alert["YOU"]),
				text2 = format(L.alert["%s Trap"],"<traptype>"),
				time = 3,
				flashtime = 3,
				color1 = "RED",
				sound = "ALERT12",
				icon = ST[99836],
			},
			riplimbcd = {
				varname = format(L.alert["%s Resurrection"],L.npc_firelands["Riplimb"]),
				type = "dropdown",
				text = format(L.alert["%s Resurrection"],L.npc_firelands["Riplimb"]),
				time = 30,
				flashtime = 5,
				color1 = "PURPLE",
				icon = ST[38601],
				sound = "ALERT6",
			},
		},
		announces = {
			immotrapsay = {
				varname = format(L.alert["%s on self"],SN[99839]),
				type = "SAY",
				msg = format(L.alert["%s on Me"],SN[99839]).."!",
			},
			crystaltrapsay = {
				varname = format(L.alert["%s on self"],SN[99836]),
				type = "SAY",
				msg = format(L.alert["%s on Me"],SN[99836]).."!",
			},
		},
		raidicons = {
			crystaltrapicon = {
				varname = SN[99836],
				type = "FRIENDLY",
				persist = 30,
				reset = 29,
				unit = "#5#",
				icon = 2,
				total = 4, -- more than 4 and you're probably screwed
			},
			rageicon = {
				varname = SN[100415],
				type = "FRIENDLY",
				persist = 15,
				reset = 2,
				unit = "#5#",
				icon = 1,
			},
		},
		events = {
			-- Rage
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 100415,
				execute = {
					{
						"raidicon","rageicon",
					},
				},
			},
			-- Hurl Spear
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 100002,
				execute = {
					{
						"quash","spearcd",
						"alert","spearwarn",
						"alert","spearcd",
					},
				},
			},
			-- Riplimb dies
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","53694"},
						"quash","spearcd",
						"alert","riplimbcd",
					},
				},
			},
			-- Immolation Trap (possibly target function, could be spammy)
			{
				type = "combatevent",
				eventtype = "SPELL_SUMMON",
				spellname = 99839,
				srcnpcid = 53691, -- Shannox
				execute = {
					{
						"quash","immotrapcd",
						"alert","immotrapcd",
						"set",{traptype = L.npc_firelands["Crystal Prison Trap"]},
					},
					{
						"target",{
							source = "#1#", 
							wait = 0.2,
							announce = "immotrapsay",
							alerts = {
								self = "trapwarn",
								unknown = {"trapwarn",text = 2},
							},
						},
					},
				},
			},
			-- Crystal Prison Trap (possibly target function, could be spammy)
			{
				type = "combatevent",
				eventtype = "SPELL_SUMMON",
				spellname = 99836,
				srcnpcid = 53691, -- Shannox
				execute = {
					{
						"quash","crystaltrapcd",
						"alert","crystaltrapcd",
						"set",{traptype = L.npc_firelands["Immolation Trap"]},
					},
					{
						"target",{
							source = "#1#", 
							wait = 0.2,
							announce = "crystaltrapsay",
							alerts = {
								self = "trapwarn",
								unknown = {"trapwarn",text = 2},
							},
						},
					},
				},
			},
			-- Crystal Prison Trap Effect
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 99837,
				dstisplayertype = true,
				execute = {
					{
						"raidicon","crystaltrapicon",
						"arrow","crystaltraparrow",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"set",{traptext = format(L.alert["%s on %s"],SN[99836],"#5#")},
						"alert","crystaltrapwarn",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","crystaltrapself",
					},
				},
			},
			-- Crystal Prison Trap Effect removed
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 99837,
				dstisplayertype = true,
				execute = {
					{
						"removeraidicon","crystaltrapicon",
						"removearrow","crystaltraparrow",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"quash","crystaltrapwarn",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"quash","crystaltrapself",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end


------------------------
-- Ragnaros
------------------------
do
	local data = {
		version = 1,
		key = "Ragnaros",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Ragnaros"],
		triggers = {
			scan = {
				52409 , -- Ragnaros
			},
		},
		onactivate = {
			tracing = {52409 }, -- Ragnaros
            tracerstart = true,
			combatstop = true,
			defeat = 52409 ,
		},
        userdata = {
        },
        onstart = {
        },
        windows = {
        },
        timers = {
        },
		alerts = {
		},
        announces = {
        },
        raidicons = {
        },
		events = {
		},
	}

	DXE:RegisterEncounter(data)
end